**IMPORTANT NOTE: This patch is intended only for Faspex version 4.4.2.**
**IMPORTANT NOTE: If you think your environment has been compromised, contact IBM Aspera support before applying the security fixes included in this patch.**

# FASPEX 4.4.2 PATCH Level 3
**Operating Systems:** Linux
**Date:** 03/15/2023

This patch includes the following fixes:

### Patch Level 3 Fixes

| GitHub Issue | Description|
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| Aspera/faspex4#446        | Return the `X-IBM-Aspera` HTTP header to show the server's current running version
| Aspera/faspex4#445        | Added a new rake task `asctl faspex:rake aspera:renew_secrets` to renew secrets and update relevant passwords in one command|
| Aspera/faspex4#443        | Read request parameters as the correct data type |
| Aspera/faspex4#440        | Enhance XML validation for endpoints that accept requests in XML format
| Aspera/faspex4#439        | Stop treating requests in XML format as request parameters|

### Patch Level 2 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-2054 | JQuery-UI: Using now jquery-ui v. 1.13.2                                                        |
| FASPX-2100 | YAML: Pre-auth RCE(Remote code execution) in /package_relay/relay_package due to insecure YAML deserialization has been supressed           |
| FASPX-2104 | XSS: Restrict render type to avoid to insecure rendering                                                       |
| FASPX-2087 | Apache: Using apache 2.4.54 now                                                       |
| FASPX-2095 | OpenSSL: Using openssl 1.1.1s now                                                     |
| FASPX-2096 | Zlib: Using zlib 1.2.13 now  

### Patch Level 1 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-2092 | Clickjacking: CSP frame-ancestors missing                                                        |

## PATCH INSTRUCTIONS
### Pre-requisite

1. Confirm the Faspex version you have currently installed. You must be on Faspex: 4.4.2.185316 to apply this patch. 
	
	    ```$ asctl faspex:version```

### Applying the patch for Linux systems:

1. Download the patch file (`IBM_Aspera_Faspex_4.4.2_Linux_Patch_Level_3.zip`) and unzip it.

2. Make sure to back up all the files in the common folder (``/opt/aspera/common/``) and faspex folder (``/opt/aspera/faspex/``).

3. Stop all services

    ```$ asctl all:stop```

4. Replace existing files by copying patch files to the appropriate directories in Common folder (`/opt/aspera/common/`) and the Faspex folder (`/opt/aspera/faspex`).

    Replacing common files:
    ```$ /bin/cp -r patch_path/IBM_Aspera_Faspex_4.4.2_Linux_Patch_Level_3/common/* /opt/aspera/common/```

    Replacing faspex files:
    ```$ /bin/cp -r patch_path/IBM_Aspera_Faspex_4.4.2_Linux_Patch_Level_3/faspex/* /opt/aspera/faspex/```

5. Start MySQL:

    ```
    asctl mysql:start
    ```

6.  Run Apache setup and use the existing configuration settings:

    ```
    asctl apache:setup


7. Run the following command to upgrade Apache:

    ```
    asctl apache:upgrade
    ```

8. Change ownership of the `/opt/aspera/faspex` folder to the `faspex` group and `faspex` user:

     ```
     cd /opt/aspera/faspex
     chown -R faspex:faspex *
     ```

9. Run the following command to get the updated database schema:

    ```
    asctl faspex:migrate_database
    ```

10. Confirm the patch was applied by checking the patch level listed in the footer (beneath the version number).


© IBM Aspera. Copyright IBM Corp. 2009, 2022
