class MTemplateController < AuthenticatedController
  layout nil
  layout "default", :except => :show_frame

  before_filter :check_admin_permissions
  before_filter :verify_user_is_server_admin

  def edit
    if EConfiguration.disable_edit_email_html?
      redirect_to :action => 'wizard', :id => params[:id] and return
    end
    @m_template = MTemplate.find(params[:id])
  end
  
  # renders an email template with dummy data
  def show
    # set dummy data
    @m_template = MTemplate.find(params[:id])
    case @m_template.name
      when "package_downloaded"
        @sender_name = 'John Smith'
        @sender_first_name = 'John'
        @sender_last_name = 'Smith'
        @sender_email = 'j.smith@asperasoft.com'
        @sender_login = 'j.smith'
        @downloader_name = 'Robert Williams'
        @downloader_first_name = 'Robert'
        @downloader_last_name = 'Williams'
        @downloader_login = 'rwilliams'
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_url = received_path(1)
        @package_size = 987253346
        @package_files = 1
        @package_partial = ''
        @downloader_email = 'r.williams@asperasoft.com'
        @package_note = 'Here is the video updated with the changes we discussed.'
        @to = 'r.williams@asperasoft.com'
        @workgroup_name = 'Special Effects'
        @replyto = @downloader_name + "<" + @downloader_email + ">"
        @all_public_recipients = 'j.smith, rwilliams, kt@asperasoft.com'
        @all_cc_recipients = 'r.robinson, js@asperasoft.com, j.doe@asperasoft.com'
        @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
        @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'

      when "package_downloaded_cc"
        @cc_name = 'Jane Doe'
        @cc_email = 'j.doe@asperasoft.com'
        @sender_name = 'John Smith'
        @sender_first_name = 'John'
        @sender_last_name = 'Smith'
        @sender_email = 'j.smith@asperasoft.com'
        @sender_login = 'j.smith'
        @downloader_name = 'Robert Williams'
        @downloader_first_name = 'Robert'
        @downloader_last_name = 'Williams'
        @downloader_login = 'r.williams'
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_size = 987253346
        @package_files = 1
        @package_partial = ''
        @downloader_email = 'r.williams@asperasoft.com'
        @package_note = 'Here is the video updated with the changes we discussed.'
        @to = 'r.williams@asperasoft.com'
        @workgroup_name = 'Special Effects'
        @replyto = @downloader_name + "<" + @downloader_email + ">"
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'
        @all_public_recipients = 'j.smith, rwilliams, kt@asperasoft.com'
        @all_cc_recipients = 'r.robinson, js@asperasoft.com, j.doe@asperasoft.com'
        @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
        @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'

      when "package_received", "workgroup_package"
        @user_name = 'John Smith'
        @user_first_name = 'John'
        @user_last_name = 'Smith'
        @server_address = EConfiguration.get_full_main_server_address
        @sender_login = 'j.smith'
        @sender_name = 'Robert Williams'
        @sender_first_name = 'Robert'
        @sender_last_name = 'Williams'
        @sender_login = 'rwilliams'
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_url = received_path(1)
        @package_size = 987253346
        @package_files = 1
        @sender_email = 'r.williams@asperasoft.com'
        @package_note = 'Here is the video updated with the changes we discussed.'
        @link_expiration_info = "The download link will expire #{Utils.admin_time_to_human_one_line(1.day.from_now)} #{Time.now.zone}"
        @to = 'j.smith@asperasoft.com'
        @workgroup_name = 'Special Effects'
        @replyto = @sender_name + "<" + @sender_email + ">"
        @all_public_recipients = 'j.smith, rwilliams, kt@asperasoft.com'
        @all_cc_recipients = 'r.robinson, js@asperasoft.com, j.doe@asperasoft.com'
        @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
        @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'

      when "package_cc_receipt_on_received", "package_cc_receipt_on_sent"
          @cc_name = 'janedoe@asperasoft.com'
          @cc_email = 'janedoe@asperasoft.com'
          @user_name = 'Hayley Martinez'
          @server_address = EConfiguration.get_full_main_server_address
          @sender_login = 'j.smith'
          @sender_name = 'Robert Williams'
          @sender_first_name = 'Robert'
          @sender_last_name = 'Williams'
          @sender_login = 'rwilliams'
          @package_name = 'Edited Video'
          @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
          @package_date = Time.now
          @package_size = 987253346
          @package_files = 1
          @sender_email = 'r.williams@asperasoft.com'
          @package_note = 'Here is the video updated with the changes we discussed.'
          @to = @cc_email
          @replyto = @sender_name + "<" + @sender_email + ">"
          @all_public_recipients = 'j.smith, rwilliams, kt@asperasoft.com'
          @all_cc_recipients = 'r.robinson, js@asperasoft.com, j.doe@asperasoft.com'
          @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
          @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'
          @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'

      when "sync_failed"
        @user_name = 'John Smith'
        @user_first_name = 'John'
        @user_last_name = 'Smith'
        @to = 'j.smith@asperasoft.com'
        @home_server_name = 'Slave1'
        @home_server_hostname = '10.0.0.1'
        @sync_error = 'The remote server could not be reached'

      when "relay_failed_admin"
        @sender_name = 'John Smith'
        @sender_first_name = 'John'
        @sender_last_name = 'Smith'
        @to = 'j.smith@asperasoft.com'
        @src_home_server_name = 'Slave1'
        @src_home_server_hostname = '10.0.0.1'
        @dest_home_server_name = 'Slave2'
        @dest_home_server_hostname = '10.0.0.2'
        @relay_error = 'The remote server could not be reached'
        @error_time = Time.now.to_s
        @recipients = "john, jane"
        @relay_details_url = "http://www.faspex.com/"
        @relay_details_link = "<a href='#'>here</a>"
        @package_name = "Edited Video"

      when "relay_failed"
        @sender_name = 'John Smith'
        @sender_first_name = 'John'
        @sender_last_name = 'Smith'
        @to = 'j.smith@asperasoft.com'
        @dest_home_server_name = 'Slave2'
        @recipients = "john, jane"
        @package_url = "http://www.faspex.com/"
        @package_link = "<a href='#'>here</a>"
        @package_name = "Edited Video"
        @package_note = "Here is the video updated with the changes we discussed."
        @package_size = 987253346
        @package_files = 1

      when "dropbox_invitation"
        @email = 'j.smith@asperasoft.com'
        @to = 'j.smith@asperasoft.com'
        @dropbox_name = "*New Videos"
        @dropbox_url = "https://example.com/aspera/faspex/external/dropboxes/3/submissions/new?passcode=XXXXXX"
        @dropbox_link = "<a href='#'>here</a>"
        @link_expiration_info = "The submission link will expire #{Utils.admin_time_to_human_one_line(1.day.from_now)} #{Time.now.zone}"
        @description = "Please upload the files discussed in the meeting to this dropbox."

      when "dropbox_submit_confirmation"
        @sender_email = 'j.smith@asperasoft.com'
        @to = 'j.smith@asperasoft.com'
        @dropbox_name = "*New Videos"
        @status_url = "https://example.com/aspera/faspex/dropboxes/3/submissions/2&passcode=XXXXXX"
        @status_link = "<a href='#'>here</a>"
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_size = 987253346
        @package_files = 1
        @package_note = 'Here is the video updated with the changes we discussed.'
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'

      when "personal_invitation"
        @email = 'j.smith@asperasoft.com'
        @to = 'j.smith@asperasoft.com'
        @recipient_name = "Joe Smith"
        @recipient_first_name = "Joe"
        @recipient_last_name = "Smith"
        @submission_url = "https://example.com/aspera/faspex/external/submissions/new?passcode=XXXXXX"
        @submission_link = "<a href='#'>here</a>"
        @link_expiration_info = "The submission link will expire #{Utils.admin_time_to_human_one_line(1.day.from_now)} #{Time.now.zone}"
        @description = "Please upload the files discussed in the meeting."

      when "personal_submit_confirmation"
        @sender_email = 'j.smith@asperasoft.com'
        @to = 'j.smith@asperasoft.com'
        @recipient_name = "Joe Smith"
        @recipient_first_name = "Joe"
        @recipient_last_name = "Smith"
        @status_url = "https://example.com/aspera/faspex/external/submission_status/2&passcode=XXXXXX"
        @status_link = "<a href='#'>here</a>"
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_size = 987253346
        @package_files = 1
        @package_note = 'Here is the video updated with the changes we discussed.'
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'

      when "upload_result"
        @sender_name = 'John Smith'
        @sender_first_name = 'John'
        @sender_last_name = 'Smith'
        @sender_email = 'j.smith@asperasoft.com'
        @sender_login = 'j.smith'
        @to = 'j.smith@asperasoft.com'
        @dropbox_name = "*New Videos"
        @status_url = "https://example.com/aspera/faspex/dropboxes/3/submissions/2&passcode=XXXXXX"
        @status_link = "<a href='#'>here</a>"
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_size = 987253346
        @package_files = 1
        @package_note = 'Here is the video updated with the changes we discussed.'
        @upload_result = "completed successfully"
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'
        @all_public_recipients = 'j.smith, rwilliams, kt@asperasoft.com'
        @all_cc_recipients = 'r.robinson, js@asperasoft.com, j.doe@asperasoft.com'
        @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
        @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'

      when "upload_result_cc"
        @cc_name = 'Jane Doe'
        @cc_email     = 'j.doe@asperasoft.com'
        @sender_name = 'John Smith'
        @sender_first_name = 'John'
        @sender_last_name = 'Smith'
        @sender_email = 'j.smith@asperasoft.com'
        @sender_login = 'j.smith'
        @to = 'j.doe@asperasoft.com'
        @dropbox_name = "*New Videos"
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_size = 987253346
        @package_files = 1
        @package_note = 'Here is the video updated with the changes we discussed.'
        @upload_result = "completed successfully"
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'
        @all_public_recipients = 'j.smith, rwilliams, kt@asperasoft.com'
        @all_cc_recipients = 'r.robinson, js@asperasoft.com, j.doe@asperasoft.com'
        @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
        @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'

      when "relay_started_cc", "relay_finished_cc", "relay_error_cc"
        @cc_name = 'John Smith'
        @cc_email = 'j.smith@asperasoft.com'
        @to = 'j.smith@asperasoft.com'
        @workgroup_name = 'Special Effects'
        @destination_node = '/server'
        @destination_directory = '/destination'
        @sender_name = 'Robert Williams'
        @sender_first_name = 'Robert'
        @sender_last_name = 'Williams'
        @sender_email = 'r.williams@asperasoft.com'
        @sender_login = 'r.williams'
        @package_name = 'Edited Video'
        @package_uuid = 'f6e5d64c-5b41-4d5e-844d-7b76c3a655f3'
        @package_date = Time.now
        @package_size = 987253346
        @package_files = 3
        @package_note = 'Here is the video updated with the changes we discussed.'
        @package_file_list_first_10 = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'
        @package_file_list_all = 'File 1.txt<br>File 2.txt<br>File 3.txt<br>'
        @replyto = @sender_name + "<" + @sender_email + ">"
        @all_public_recipients = 'j.smith, rwilliams, kt@asperasoft.com'
        @all_cc_recipients = 'r.robinson, js@asperasoft.com, j.doe@asperasoft.com'
        @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
        @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'

      when "package_validation_failed_sender", "package_validation_failed_recipient"
        @status_url = "https://example.com/aspera/faspex/external/submission_status/2&passcode=XXXXXX"
        @status_link = "<a href='#'>here</a>"
        @sender_name = 'John Smith'
        @sender_first_name = 'John'
        @sender_last_name = 'Smith'
        @user_name = 'Jane Doe'
        @to = 'j.smith@asperasoft.com'
        @recipients = "john, jane"
        @package_name = "Edited Video"
        @package_date = Time.now
        @package_note = "Here is the video updated with the changes we discussed."
        @package_size = 987253346
        @package_files = 1
        @package_url = received_path(1)
        @all_public_recipients_email = 'jsmith@asperasoft.com, rwilliams@asperasoft.com, kt@asperasoft.com'
        @all_cc_recipients_email = 'rrobinson@asperasoft.com, js@asperasoft.com, j.doe@asperasoft.com'
        @validation_error = "File validation error \n"

      else
        @user_name = 'John Smith'
        @user_first_name = 'John'
        @user_last_name = 'Smith'
        @to = 'j.smith@asperasoft.com'
        @login = 'jsmith'
        @reset_url = edit_reset_password_url("sampletoken")
        @server_address = EConfiguration.get_full_main_server_address
        @comments = "[Additional comments can be added in this paragraph when a user is created]"
    end

    if addrs = EConfiguration.first.alternate_addresses
      addrs.each_with_index do |a, i|
        name = "alternate_address_" + (i + 1).to_s
        instance_variable_set("@#{name}", a.address_name)
      end
      @primary_address = EConfiguration.first.e_server_address
    end

    @full_subject = @m_template.subject
    @full_subject = @full_subject.sub('PACKAGE_FILE_LIST_FIRST_10', @package_file_list_first_10 || 'PACKAGE_FILE_LIST_FIRST_10')
    @full_subject = @full_subject.sub('PACKAGE_FILE_LIST_ALL', @package_file_list_all || 'PACKAGE_FILE_LIST_ALL')
    @full_subject = @full_subject.sub('DESTINATION_NODE', @destination_node || 'DESTINATION_NODE')
    @full_subject = @full_subject.sub('DESTINATION_DIRECTORY', @destination_directory || 'DESTINATION_DIRECTORY')
    @full_subject = @full_subject.sub('MOBILE_PACKAGE_URL', !@package_url.nil? ? @package_url.sub(/https?/, 'faspex-pkg') : 'MOBILE_PACKAGE_URL')
    @full_subject = @full_subject.sub('PACKAGE_NAME', @package_name || 'PACKAGE_NAME')
    @full_subject = @full_subject.sub('PACKAGE_UUID', @package_uuid || 'PACKAGE_UUID')
    @full_subject = @full_subject.sub('PACKAGE_DATE', @package_date.to_s || 'PACKAGE_DATE')
    @full_subject = @full_subject.sub('PACKAGE_URL', @package_url || 'PACKAGE_URL')
    @full_subject = @full_subject.sub('PACKAGE_SIZE', @package_size.to_s || 'PACKAGE_SIZE')
    @full_subject = @full_subject.sub('PACKAGE_FILES', @package_files.to_s || 'PACKAGE_FILES')
    @full_subject = @full_subject.sub('PACKAGE_NOTE', @package_note || 'PACKAGE_NOTE')
    @full_subject = @full_subject.sub('PACKAGE_LINK', @package_link || 'PACKAGE_LINK')
    @full_subject = @full_subject.sub('LINK_EXPIRATION_INFO', @link_expiration_info || 'LINK_EXPIRATION_INFO')
    @full_subject = @full_subject.sub('SERVER_ADDRESS', @server_address || 'SERVER_ADDRESS')
    @full_subject = @full_subject.sub('DOWNLOADER_NAME', @downloader_name || 'DOWNLOADER_NAME')
    @full_subject = @full_subject.sub('DOWNLOADER_FIRST_NAME', @downloader_first_name || 'DOWNLOADER_FIRST_NAME')
    @full_subject = @full_subject.sub('DOWNLOADER_LAST_NAME', @downloader_last_name || 'DOWNLOADER_LAST_NAME')
    @full_subject = @full_subject.sub('DOWNLOADER_EMAIL', @downloader_email || 'DOWNLOADER_EMAIL')
    @full_subject = @full_subject.sub('WORKGROUP_NAME', @workgroup_name || 'WORKGROUP_NAME')
    @full_subject = @full_subject.sub('USER_NAME', @user_name || 'USER_NAME')
    @full_subject = @full_subject.sub('USER_FIRST_NAME', @user_first_name || 'USER_FIRST_NAME')
    @full_subject = @full_subject.sub('USER_LAST_NAME', @user_last_name || 'USER_LAST_NAME')
    @full_subject = @full_subject.sub('SENDER_NAME', @sender_name || 'SENDER_NAME')
    @full_subject = @full_subject.sub('SENDER_FIRST_NAME', @sender_first_name || 'SENDER_FIRST_NAME')
    @full_subject = @full_subject.sub('SENDER_LAST_NAME', @sender_last_name || 'SENDER_LAST_NAME')
    @full_subject = @full_subject.sub('SENDER_EMAIL', @sender_email || 'SENDER_EMAIL')
    @full_subject = @full_subject.sub('CC_EMAIL', @cc_email || 'CC_EMAIL')
    @full_subject = @full_subject.sub('CC_NAME', @cc_name || 'CC_NAME')
    @full_subject = @full_subject.sub('SENDER_LOGIN', @sender_login || 'SENDER_LOGIN')
    @full_subject = @full_subject.sub('LOGIN', @login || 'LOGIN')
    @full_subject = @full_subject.sub('EMAIL', @email || 'EMAIL')
    @full_subject = @full_subject.sub('DROPBOX_NAME', @dropbox_name || 'DROPBOX_NAME')
    @full_subject = @full_subject.sub('DROPBOX_URL', @dropbox_url || 'DROPBOX_URL')
    @full_subject = @full_subject.sub('DROPBOX_LINK', @dropbox_link || 'DROPBOX_LINK')
    @full_subject = @full_subject.sub('RECIPIENT_NAME', @recipient_name || 'RECIPIENT_NAME')
    @full_subject = @full_subject.sub('RECIPIENT_FIRST_NAME', @recipient_first_name || 'RECIPIENT_FIRST_NAME')
    @full_subject = @full_subject.sub('RECIPIENT_LAST_NAME', @recipient_last_name || 'RECIPIENT_LAST_NAME')
    @full_subject = @full_subject.sub('UPLOAD_RESULT', @upload_result || 'UPLOAD_RESULT')
    @full_subject = @full_subject.sub('SRC_HOME_SERVER_HOSTNAME', @home_server_hostname || '10.0.0.1')
    @full_subject = @full_subject.sub('SRC_HOME_SERVER_NAME', @home_server_name || 'Slave 1')
    @full_subject = @full_subject.sub('RECIPIENTS', @recipients || 'RECIPIENTS')
    @full_subject = @full_subject.sub('RELAY_ERROR', @relay_error || 'RELAY_ERROR')
    @full_subject = @full_subject.sub('RELAY_DETAILS_URL', @relay_details_url || 'RELAY_DETAILS_URL')
    @full_subject = @full_subject.sub('RELAY_DETAILS_LINK', @relay_details_link || 'RELAY_DETAILS_LINK')
    @full_subject = @full_subject.sub('ERROR_TIME', @error_time || 'ERROR_TIME')
    @full_subject = @full_subject.sub('DEST_HOME_SERVER_HOSTNAME', @home_server_hostname || '10.0.0.2')
    @full_subject = @full_subject.sub('DEST_HOME_SERVER_NAME', @home_server_name || 'Slave 2')
    @full_subject = @full_subject.sub('SYNC_ERROR', @sync_error || 'SYNC_ERROR')
    @full_subject = @full_subject.sub('HOME_SERVER_HOSTNAME', @home_server_hostname || '10.0.0.1')
    @full_subject = @full_subject.sub('ALL_PUBLIC_RECIPIENTS_EMAIL', @all_public_recipients_email || 'ALL_PUBLIC_RECIPIENTS')
    @full_subject = @full_subject.sub('ALL_PUBLIC_RECIPIENTS', @all_public_recipients || 'ALL_PUBLIC_RECIPIENTS')
    @full_subject = @full_subject.sub('ALL_CC_RECIPIENTS_EMAIL', @all_cc_recipients_email || 'ALL_CC_RECIPIENTS')
    @full_subject = @full_subject.sub('ALL_CC_RECIPIENTS', @all_cc_recipients || 'ALL_CC_RECIPIENTS')
    @full_subject = @full_subject.sub('HOME_SERVER_NAME', @home_server_name || 'Slave 1')
    @full_subject = @full_subject.sub(/&lt;br&gt;/, '<br>')
    @full_subject = @full_subject.sub('<a', '<a onclick="return false;"')
    # generate rhtml file if it doesn't exist
    @m_template.generate_rhtml(false)
    @header_email = render_to_string :template => "layouts/email.text.html.rhtml", :layout => false
    # render email frame
    @full_email = render_to_string :template => "notifier/#{@m_template.name}_notification.text.html.rhtml", :layout => false
    # replace html escaped <br> tag with '<br>' string again
    @full_email.gsub!(/&lt;br&gt;/, '<br>')
    # disable links in preview
    @full_email.gsub!('<a', '<a onclick="return false;"')

  end

  # handles saving from both the wizard and html edit
  def update
    @m_template = MTemplate.find(params[:id])
    # generate email if saved from wizard
    if params[:btnSaveFromWizard]
      # set instance vars and update attributes before rendering
      sanitized_attributes = Hash[params[:m_template].map { |k, v|
          [k, @template.strip_bad_tags(v)]
      } ]
      @m_template.attributes = sanitized_attributes
      @m_template.full_email = render_to_string(:partial => 'wizard_template')
      if @m_template.save
        flash[:notice] = t('app.controllers.m_template_controller.updated', template: (CGI.escapeHTML(@m_template.name.titleize)))
        redirect_to :action => 'show', :id => @m_template.id
      else
        render :action => 'wizard'
      end
    elsif params[:btnLoadDefaults]
      @default_template = MTemplate.find(MTemplate.customized_id_to_default_id(@m_template.id))
      @m_template.update_attributes(@default_template.attributes.except("id", "created_at", "updated_at", "name"))
      flash[:notice] = t('app.controllers.m_template_controller.loaded')
      render :action => 'wizard'
    else
      @m_template.full_email = @template.strip_bad_tags(params[:m_template][:full_email] || '')
      @m_template.subject = @template.strip_bad_tags(params[:m_template][:subject] || '')
      if @m_template.save
        flash[:notice] = t('app.controllers.m_template_controller.updated', template: (CGI.escapeHTML(@m_template.name.titleize)))
        redirect_to :action => 'show', :id => @m_template.id
      else
        render :action => 'edit'
      end
    end
  end

  def wizard
    @m_template = MTemplate.find(params[:id])
  end

  private

  def check_admin_permissions
    # check_permissions method in AuthenticatedController has already checked
    # for a valid user
    logged_in_user = current_user

    # check if user is admin
    if !logged_in_user.admin?
      logger.error("SECURITY: Denied access to user (id = " +
        "#{logged_in_user.id}) attempting to access admin pages for " +
        "customizing e-mail notifications.")
      session[:error_message] = "Access denied."
      redirect_to :controller => 'e_error', :action => 'show_error'
    end
  end
end
